#include "er.h"
#include "cfg_common.h"
#include "messages.h"
#include "actions.h"

void DrawCase(int case_num, int num_lines, int btn, char *text)
{
    //to do: num_lines = 2
    int x = 0;
    int y = 80;
    DrawImageResource(EINK, x, case_num*y, "CONF_CASE");
    TextOutCenter(EINK, x+60, case_num*y, 600-60-60, 80, 1, 0, text);

    if (btn == 1) DrawImageResource(EINK, x+24, case_num*y+28, "CONF_CHB_0");
    if (btn == 2) DrawImageResource(EINK, x+24, case_num*y+28, "CONF_CHB_1");
    if (btn == 3) DrawImageResource(EINK, x+24, case_num*y+28, "CONF_LBUT");
}

void DrawBot(char *t1, char *t2, char *t3, char *t4, char *t5)
{
    int x, y, w;
    x = 8;
    y = 740;
    w = 112;

    DrawImageResource(EINK, 0, 720, "CONF_BOT");

    SetCurrFont(sysFont);

    if (t1)
    {
        DrawImageResource(EINK, x, y, "CONF_BBUT");
        TextOutCenter(EINK, x, y, w, 40, 0, 0, t1);
    }
    x+=w+8;

    if (t2)
    {
        DrawImageResource(EINK, x, y, "CONF_BBUT");
        TextOutCenter(EINK, x, y, w, 40, 0, 0, t2);
    }
    x+=w+4;

    if (t3)
    {
        DrawImageResource(EINK, x, y, "CONF_BBUT");
        TextOutCenter(EINK, x, y, w, 40, 0, 0, t3);
    }
    x+=w+4;

    if (t4)
    {
        DrawImageResource(EINK, x, y, "CONF_BBUT");
        TextOutCenter(EINK, x, y, w, 40, 0, 0, t4);
    }
    x+=w+8;

    if (t5)
    {
        DrawImageResource(EINK, x, y, "CONF_BBUT");
        TextOutCenter(EINK, x, y, w, 40, 0, 0, t5);
    }
}

void DrawTop(int p)
{

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang==0) DrawImageResource(EINK, 8, 8, "CONF_BAN_CONF_EN");
    if (opt_new.lang==1) DrawImageResource(EINK, 8, 8, "CONF_BAN_CONF_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;
    int tw1 = 184;
    int th1 = 44;

    if (p == 1)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_INFO");
        TextOutCenter(EINK, x+48, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page1_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_INFO");
        x += tw0;
    }

    if (p == 2)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_FONT");
        TextOutCenter(EINK, x+48, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page2_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_FONT");
        x += tw0;
    }

    if (p == 3)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_PARAGRAPH");
        TextOutCenter(EINK, x+48, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page3_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_PARAGRAPH");
        x += tw0;
    }

    if (p == 4)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_PAGE");
        TextOutCenter(EINK, x+48, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page4_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_PAGE");
        x += tw0;
    }

    if (p == 5)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_SBT");
        TextOutCenter(EINK, x+40, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page5_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_SBT");
        x += tw0;
    }

    if (p == 6)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_SBB");
        TextOutCenter(EINK, x+40, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page6_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_SBB");
        x += tw0;
    }

    if (p == 7)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_MISC");
        TextOutCenter(EINK, x+48, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page7_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_MISC");
        x += tw0;
    }

    if (p == 8)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        DrawImageResource(EINK, x+12, y+12, "CONF_I_FILES");
        TextOutCenter(EINK, x+48, y+4, tw1-56, th1-4, 1, 0, txt.cfg_page8_title);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        DrawImageResource(EINK, x+16, y+12, "CONF_I_FILES");
        x += tw0;
    }
}

void ShowConfig(int p)
{
    int i;
    SetLang(opt_new.lang);
    if (p == 1) i = OpenScreen(0, cfgPg1_Handler, "ConfigPg1", 7001);
    if (p == 2) i = OpenScreen(0, cfgPg2_Handler, "ConfigPg2", 7002);
    if (p == 3) i = OpenScreen(0, cfgPg3_Handler, "ConfigPg3", 7003);
    if (p == 4) i = OpenScreen(0, cfgPg4_Handler, "ConfigPg4", 7004);
    if (p == 5) i = OpenScreen(0, cfgPg5_Handler, "ConfigPg5", 7005);
    if (p == 6) i = OpenScreen(0, cfgPg6_Handler, "ConfigPg6", 7006);
    if (p == 7) i = OpenScreen(0, cfgPg7_Handler, "ConfigPg7", 7007);
    if (p == 8) i = OpenScreen(0, cfgPg8_Handler, "ConfigPg8", 7008);
    if (p == 9) i = OpenScreen(0, SelFont_Handler,"SelectFont", 7009);
    if (p ==10) i = OpenScreen(0, SelPDB_Handler, "SelectPDB", 7010);
    if (p ==11) i = OpenScreen(0, Help_Handler, "Help", 7011);
    if (p ==12) i = OpenScreen(0, SelKey_Handler, "Keys", 7012);
    if (p ==13) i = OpenScreen(0, SelAct_Handler, "Actions", 7013);
}

void SaveOptions()
{
    if (LOG) log("<SaveOptions>\0");

    int optfile, size;
    
    DeleteFile("B:\\System\\Config\\ezhik.cfg");
    optfile = CreateFile("B:\\System\\Config\\ezhik.cfg");
    if (optfile)
    {
        WriteFile(optfile, &opt, sizeof(struct options_struct), &size);
        SaveFonts(optfile);
        CloseFile(optfile);
    }

    if (LOG) log("</SaveOptions>\0>");
}

void LoadOptions()
{
    if (LOG) log("<LoadOptions>\0");

    int optfile, size;
    char loaded=0;

    optfile = CreateFile("B:\\System\\Config\\ezhik.cfg");
    if (optfile)
    {
        ReadFile(optfile, &opt, sizeof(struct options_struct), &size);
        LoadFonts(optfile);
        CloseFile(optfile);
        if ((size!=0)&&(version==opt.version)) loaded = 1;
    }

    if (!loaded)
    {
      if (LOG) log("<LoadDefaultOptions/>\0");
      SetDefOptions(&opt);
      InitFonts();
    }
    opt_new = opt;

    if (LOG) log("</LoadOptions>\0");
}

void cfgMain_Paint()
{
    if ((opt.page.layout==1)||(opt.page.layout==3)) SetLayout(EINK, 0);
}

int cfgMain_Init(struct event *e)
{
    exit_cfg_Ok = 0;
    exit_cfg_Cancel = 0;
    opt_new = opt;
    return 0;
}

int cfgMain_Exit(struct event *e)
{
    if ((config_changed==0)||(exit_cfg_Cancel == 1)) 
    {
        opt_new = opt;
    }
    if ((config_changed==1)&&(exit_cfg_Ok == 1)) 
    {
        opt = opt_new;
        SaveOptions();
    }
    return 0;
}

int cfgMain_Show(struct event *e)
{
    if ((exit_cfg_Ok == 0)&&(exit_cfg_Cancel == 0))
    {
        SetLayout(EINK, 0);
        ShowConfig(opt_new.cfg_page);
    }
    else
    {
        CloseScreen();
    }
    return 0;
}

int cfgMain_KeyPress(struct event *e)
{
    return 0;
}

static const struct evtproc cfgMain_evtproc[] =
{
    { EVT_INIT, cfgMain_Init },
    { EVT_SHOW, cfgMain_Show },
    { EVT_KEYPRESS, cfgMain_KeyPress },
    { EVT_EXIT, cfgMain_Exit },
    { 0,    NULL },
};

void cfgMain_Handler()
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgMain_evtproc, &evt);
    TranslateEvent(&evt);
}
