#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg5_Paint() 
{                   
    char buf[256];
    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    if (opt_new.statusbar_t.visible == 0) 
    {
        sprintf(buf, "%s: %s", txt.cfg_page5_1, txt.Off);
        DrawCase(1, 1, 1, buf);
    } 
    else 
    {
        sprintf(buf, "%s: %s", txt.cfg_page5_1, txt.On);
        DrawCase(1, 1, 2, buf);
    }

    int i = opt_new.statusbar_t.font;
    if (i>=17)
    {
        SetCurrFont(sysFont);
        memset(buf,0,256);
        sprintf(buf, "%s, PDB: %s", txt.cfg_page5_2_0, GetLongFontName(fonts[i]->PDB_file));
    }
    else
    {
        SetCurrFont(i);
        memset(buf,0,256);
        sprintf(buf, "%s", txt.cfg_page5_2_0);
    }
    DrawCase(2, 1, 3, buf);
    SetCurrFont(sysFont);
    memset(buf,0,256);

    switch (opt_new.statusbar_t.progress) 
    {
    case 0: 
        sprintf(buf, "%s: %s", txt.cfg_page5_3, txt.Off);
        DrawCase(3, 1, 1, buf);
        break;
    case 1:
        sprintf(buf, "%s: %s", txt.cfg_page5_3, txt.cfg_page5_3_1);
        DrawCase(3, 1, 2, buf);
        break;
    case 2:
        sprintf(buf, "%s: %s", txt.cfg_page5_3, txt.cfg_page5_3_2);
        DrawCase(3, 1, 2, buf);
        break;
    case 3:
        sprintf(buf, "%s: %s", txt.cfg_page5_3, txt.cfg_page5_3_3);
        DrawCase(3, 1, 2, buf);
        break;
    }

    switch (opt_new.statusbar_t.battery) 
    {
    case 0:
        sprintf(buf, "%s: %s", txt.cfg_page5_4, txt.Off);
        DrawCase(4, 1, 1, buf);
        break;
    case 1:
        sprintf(buf, "%s: %s", txt.cfg_page5_4, txt.cfg_page5_4_1);
        DrawCase(4, 1, 2, buf);
        break;
    case 2:
        sprintf(buf, "%s: %s", txt.cfg_page5_4, txt.cfg_page5_4_2);
        DrawCase(4, 1, 2, buf);
        break;
    case 3:
        sprintf(buf, "%s: %s", txt.cfg_page5_4, txt.cfg_page5_4_3);
        DrawCase(4, 1, 2, buf);
        break;
    case 4:
        sprintf(buf, "%s: %s", txt.cfg_page5_4, txt.cfg_page5_4_4);
        DrawCase(4, 1, 2, buf);
        break;
    case 5:
        sprintf(buf, "%s: %s", txt.cfg_page5_4, txt.cfg_page5_4_5);
        DrawCase(4, 1, 2, buf);
        break;
    }

    switch (opt_new.statusbar_t.info) 
    {
    case 0:
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.Off);
        DrawCase(5, 1, 1, buf);
        break;
    case 1:
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.cfg_page5_5_1);
        DrawCase(5, 1, 2, buf);
        break;
    case 2: 
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.cfg_page5_5_2);
        DrawCase(5, 1, 2, buf);
        break;
    case 3: 
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.cfg_page5_5_3);
        DrawCase(5, 1, 2, buf);
        break;
    case 4: 
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.cfg_page5_5_4);
        DrawCase(5, 1, 2, buf);
        break;
    case 5: 
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.cfg_page5_5_5);
        DrawCase(5, 1, 2, buf);
        break;
    case 6: 
        sprintf(buf, "%s: %s", txt.cfg_page5_5, txt.cfg_page5_5_6);
        DrawCase(5, 1, 2, buf);
        break;
    }

    switch (opt_new.statusbar_t.style) 
    {
    case 0: 
        sprintf(buf, "%s: %s", txt.cfg_page5_6, txt.Off);
        DrawCase(6, 1, 1, buf);
        break;
    case 1: 
        sprintf(buf, "%s: %s", txt.cfg_page5_6, txt.cfg_page5_6_1);
        DrawCase(6, 1, 2, buf);
        break;
    case 2: 
        sprintf(buf, "%s: %s", txt.cfg_page5_6, txt.cfg_page5_6_2);
        DrawCase(6, 1, 2, buf);
        break;
    case 3: 
        sprintf(buf, "%s: %s", txt.cfg_page5_6, txt.cfg_page5_6_3);
        DrawCase(6, 1, 2, buf);
        break;
    case 4: 
        sprintf(buf, "%s: %s", txt.cfg_page5_6, txt.cfg_page5_6_4);
        DrawCase(6, 1, 2, buf);
        break;
    }

    switch (opt_new.statusbar_t.time) 
    {
    case 0: 
        sprintf(buf, "%s: %s", txt.cfg_page5_7, txt.Off);
        DrawCase(7, 1, 1, buf);
        break;
    case 1: 
        sprintf(buf, "%s: %s", txt.cfg_page5_7, txt.cfg_page5_7_1);
        DrawCase(7, 1, 2, buf);
        break;
    case 2: 
        sprintf(buf, "%s: %s", txt.cfg_page5_7, txt.cfg_page5_7_2);
        DrawCase(7, 1, 2, buf);
        break;
    case 3: 
        sprintf(buf, "%s: %s", txt.cfg_page5_7, txt.cfg_page5_7_3);
        DrawCase(7, 1, 2, buf);
        break;
    case 4: 
        sprintf(buf, "%s: %s", txt.cfg_page5_7, txt.cfg_page5_7_4);
        DrawCase(7, 1, 2, buf);
        break;
    case 5: 
        sprintf(buf, "%s: %s", txt.cfg_page5_7, txt.cfg_page5_7_5);
        DrawCase(7, 1, 2, buf);
        break;
    }

    sprintf(buf, "%s%i", txt.cfg_page5_8_0, opt_new.statusbar_t.color);
    DrawCase(8, 1, 3, buf);
    switch (opt_new.statusbar_t.color) 
    {
    case 0: 
        break;
    case 1: 
        FillArea(EINK, 60, 660, 480, 40, 1, AND);
        break;
    case 2: 
        FillArea(EINK, 60, 660, 480, 40, 2, AND);
        break;
    case 3: 
        FillArea(EINK, 60, 660, 480, 40, 2, SET);
        break;
    case 4: 
        FillArea(EINK, 60, 660, 480, 40, 1, SET);
        break;
    case 5: 
        FillArea(EINK, 60, 660, 480, 40, 2, AND);
        FillArea(EINK, 60, 660, 480, 40, 1, OR);
        break;
    case 6: 
        FillArea(EINK, 60, 660, 480, 40, 1, AND);
        FillArea(EINK, 60, 660, 480, 40, 2, OR);
        break;
    case 7: 
        FillArea(EINK, 60, 660, 480, 40, 3, OR);
        break;
    }

    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg5_Init(struct event *e) 
{
    return 0;
}

int cfgPg5_Exit(struct event *e) 
{
    return 0;
}

int cfgPg5_Show(struct event *e) 
{
    if (sel_font.id == 2) 
    {
        if (sel_font.result!=-1) 
        {
            opt_new.statusbar_t.font = sel_font.result;
        }
        sel_font.id = 0;
        sel_font.result = -1;
    }
    cfgPg5_Paint();
    return 0;
}

int cfgPg5_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_1:
        opt_new.statusbar_t.visible = 1 - opt_new.statusbar_t.visible;
        cfgPg5_Paint();
        break;
    case KEY_2:
        sel_font.id = 2;
        ShowConfig(9);
        break;
    case KEY_3:
        opt_new.statusbar_t.progress++;
        if (opt_new.statusbar_t.progress == 4) opt_new.statusbar_t.progress = 0;
        cfgPg5_Paint();
        break;
    case KEY_4:
        opt_new.statusbar_t.battery++;
        if (opt_new.statusbar_t.battery == 6) opt_new.statusbar_t.battery = 0;
        cfgPg5_Paint();
        break;
    case KEY_5:
        opt_new.statusbar_t.info++;
        if (opt_new.statusbar_t.info == 7) opt_new.statusbar_t.info = 0;
        cfgPg5_Paint();
        break;
    case KEY_6:
        opt_new.statusbar_t.style++;
        if (opt_new.statusbar_t.style == 5) opt_new.statusbar_t.style = 0;
        cfgPg5_Paint();
        break;
    case KEY_7:
        opt_new.statusbar_t.time++;
        if (opt_new.statusbar_t.time == 6) opt_new.statusbar_t.time = 0;
        cfgPg5_Paint();
        break;
    case KEY_8:
        opt_new.statusbar_t.color++;
        if (opt_new.statusbar_t.color == 8) opt_new.statusbar_t.color = 0;
        cfgPg5_Paint();
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;    
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        config_changed = 1;
        exit_cfg_Ok = 1;
        if (opt_new.statusbar_t.visible==0) opt_new.statusbar_t.height = 0;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg5_evtproc[] = 
{
    { EVT_INIT, cfgPg5_Init },
    { EVT_SHOW, cfgPg5_Show },
    { EVT_KEYPRESS, cfgPg5_KeyPress },
    { EVT_EXIT, cfgPg5_Exit },
    { 0,    NULL },
};

void cfgPg5_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg5_evtproc, &evt);
    TranslateEvent(&evt);
}
