#include "er.h"
#include "cfg_common.h"
#include "messages.h"

unsigned char keypage, kpage, keycount, ktop;

void SelKey_DrawTop(int p)
{
    char buf[256];

    SetCurrFont(sysFont);

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang == 0) DrawImageResource(EINK, 8, 8, "CONF_BAN_KEY_EN");
    if (opt_new.lang == 1) DrawImageResource(EINK, 8, 8, "CONF_BAN_KEY_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;
    int tw1 = 184;
    int th0 = 40;
    int th1 = 44;

    if (p == 1)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "1");
        x += tw0;
    }

    if (keypage>=2)
    {
        if (p == 2)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "2");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "2");
            x += tw0;
        }
    }

    if (keypage>=3)
    {
        if (p == 3)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "3");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "3");
            x += tw0;
        }
    }

    if (keypage>=4)
    {
        if (p == 4)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "4");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "4");
            x += tw0;
        }
    }

    if (keypage>=5)
    {
        if (p == 5)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "5");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "5");
            x += tw0;
        }
    }

    if (keypage>=6)
    {
        if (p == 6)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "6");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "6");
            x += tw0;
        }
    }

    if (keypage>=7)
    {
        if (p == 7)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "7");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "7");
            x += tw0;
        }
    }

    if (keypage>=8)
    {
        if (p == 8)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "8");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "8");
            x += tw0;
        }
    }
}

void SelKey_Paint()
{
    int i;
    char buf[100];

    ClearWindow(EINK);

    SelKey_DrawTop(kpage);

    for (i=ktop; i<(ktop+8); i++)
    {
        if (i < keycount)
        {
            sprintf(buf, "\"%s\": %s", txt.cfg_key[i], txt.cfg_act[opt_new.key_mapping[i]]);
            DrawCase(i-ktop+1, 1, 3, buf);
        }
        else
        {
            DrawCase(i-ktop+1, 1, 0, "");
        }
    }
    DrawBot(txt.dialog_Ok, 0, 0, 0, 0);
}

int SelKey_Init(struct event *e)
{
    keycount = 32;
    keypage = 4;

    ktop = 0;
    kpage = 1;

    return 0;
}

int SelKey_Exit(struct event *e)
{
    return 0;
}

int SelKey_Show(struct event *e)
{
    SelKey_Paint();
    return 0;
}

int SelKey_KeyPress(struct event *e)
{
    int key = e->par1;

    if ((key>0x30)&&(key<0x39)&&((key-0x31+ktop)<keycount))
    {
        curr_key = key-0x31+ktop;
        ShowConfig(13);
    }
    else
    {
        switch (key)
        {
        case KEY_PREV:
            kpage--;
            if (kpage==0) kpage = keypage;
            ktop = (kpage-1)*8;
            SelKey_Paint();
            break;
        case KEY_NEXT:
            kpage++;
            if (kpage>keypage) kpage = 1;
            ktop = (kpage-1)*8;
            SelKey_Paint();
            break;
        case KEY_SHELF:  e->type = 0;
        case KEY_INFO:
            CloseScreen();
            break;
        }
    }
    return 0;
}

static const struct evtproc selKey_evtproc[] =
{
    { EVT_INIT, SelKey_Init },
    { EVT_SHOW, SelKey_Show },
    { EVT_KEYPRESS, SelKey_KeyPress },
    { EVT_EXIT, SelKey_Exit },
    { 0,    NULL },
};

void SelKey_Handler()
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(selKey_evtproc, &evt);
    TranslateEvent(&evt);
}
