#ifndef _ALLEXTERN_H_
#define _ALLEXTERN_H_

// --- GLOBAL VARIABLES ---
extern struct options_struct opt, opt_new;
// --- file ---
extern char *filename, *pos_filename, *bkmrk_filename;
extern char title[64];
extern char *fb2_authors, *fb2_title;
extern int version;
extern int fd;
extern long int fd_size, prev_pos;
// --- windows ---
extern struct out_areas out_area;
extern unsigned char exit_cfg_Ok, exit_cfg_Cancel, exit_prg;
extern struct dialog_struct dialog;
// --- text parsing ---
extern struct pages page[NUM_PAGES];
extern struct data_struct *data;
extern struct styles_tree *curr_style;
extern char *pagebuffer;
extern int prev_page, curr_page, next_page;
extern unsigned char allow_prev_page;
// --- fonts ---
extern struct font_struct *curr_font, *fonts[MAX_FONTS];
extern unsigned char sysFont;
extern int fontCacheLeft;
extern struct statistics *stat;
// --- bookmarks ---
extern unsigned char bkmrk_count, bkmrk_curr, bkmrk_goto;
extern struct bookmarks *bookmark[64];
// --- misc ---
extern unsigned char config_changed, config_reInitFont, config_resetStat, help_page, curr_key;
extern unsigned char file_type, codepage;
extern unsigned char save_progress;
extern struct cfg_font sel_font;
extern unsigned char lock_key;

#endif
