#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg8_Paint() 
{                   
    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    DrawCase(1, 1, 3, txt.cfg_page8_1_0);
    DrawCase(2, 1, 0, "");
    DrawCase(3, 1, 0, "");
    DrawCase(4, 1, 0, "");
    DrawCase(5, 1, 0, "");
    DrawCase(6, 1, 0, "");
    DrawCase(7, 1, 0, "");
    DrawCase(8, 1, 0, "");  
    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg8_Init(struct event *e) 
{
    ResetDialog();
    return 0;
}

int cfgPg8_Exit(struct event *e) 
{
    return 0;
}

int cfgPg8_Show(struct event *e) 
{
    if (dialog.result==0) cfgPg8_Paint();  

    if ((dialog.id==1)&&(dialog.result==1)) 
    {
        SetDefOptions(&opt);
        opt_new = opt;
        CloseScreen();
    }
    
    return 0;
}

int cfgPg8_KeyPress(struct event *e) 
{

    int key = e->par1;
    switch (key) 
    {
    case KEY_1:
        dialog.id = 1;
        ShowDialog(0, 0, 0, 0, 0, 1, txt.confirm_reset_opt);
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;    
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        exit_cfg_Ok = 1;
        config_changed = 1;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg8_evtproc[] = 
{
    { EVT_INIT, cfgPg8_Init },
    { EVT_SHOW, cfgPg8_Show },
    { EVT_KEYPRESS, cfgPg8_KeyPress },
    { EVT_EXIT, cfgPg8_Exit },
    { 0,    NULL },
};

void cfgPg8_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg8_evtproc, &evt);
    TranslateEvent(&evt);
}
