#include "er.h"
#include "cfg_common.h"
#include "messages.h"

unsigned char actpage, apage, actcount, atop;

void SelAct_DrawTop(int p) 
{
    char buf[256];

    SetCurrFont(sysFont); 

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang == 0) DrawImageResource(EINK, 8, 8, "CONF_BAN_ACT_EN");
    if (opt_new.lang == 1) DrawImageResource(EINK, 8, 8, "CONF_BAN_ACT_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;  
    int tw1 = 184;
    int th0 = 40;  
    int th1 = 44;

    if (p == 1) 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    } 
    else 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "1");
        x += tw0;
    }

    if (actpage>=2) 
    {
        if (p == 2) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "2");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "2");
            x += tw0;
        }
    }

    if (actpage>=3) 
    {
        if (p == 3) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "3");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "3");
            x += tw0;
        }
    }

    if (actpage>=4) 
    {
        if (p == 4) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "4");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "4");
            x += tw0;
        }
    }

    if (actpage>=5) 
    {
        if (p == 5) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "5");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "5");
            x += tw0;
        }
    }

    if (actpage>=6) 
    {
        if (p == 6) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "6");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "6");
            x += tw0;
        }
    }

    if (actpage>=7) 
    {
        if (p == 7) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "7");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "7");
            x += tw0;
        }
    }

    if (actpage>=8) 
    {
        if (p == 8) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "8");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "8");
            x += tw0;
        }
    }
}

void SelAct_Paint() 
{
    int i;
    
    ClearWindow(EINK);

    SelAct_DrawTop(apage);

    for (i=atop; i<(atop+8); i++) 
    {
        if (i < actcount) 
            DrawCase(i-atop+1, 1, 3, txt.cfg_act[i]);
        else 
            DrawCase(i-atop+1, 1, 0, "");
    }  
    DrawBot(0, 0, 0, 0, txt.dialog_Cancel);
}

int SelAct_Init(struct event *e) 
{
    actcount = 21;
    actpage = 3;  
    atop = 0;
    apage = 1;
    return 0;
}

int SelAct_Exit(struct event *e) 
{
    return 0;
}

int SelAct_Show(struct event *e) 
{
    SelAct_Paint();
    return 0;
}

int SelAct_KeyPress(struct event *e) 
{
    int key = e->par1;

    if ((key>0x30)&&(key<0x39)&&((key-0x31+atop)<actcount)) 
    {
        opt_new.key_mapping[curr_key] = (key-0x31)+atop;
        CloseScreen();
    }
    else 
    {
        switch (key) 
        {
        case KEY_PREV:
            apage--;
            if (apage==0) apage = actpage;
            atop = (apage-1)*8;
            SelAct_Paint();        
            break;
        case KEY_NEXT:
            apage++;
            if (apage>actpage) apage = 1;
            atop = (apage-1)*8;
            SelAct_Paint();
            break;
        case KEY_SHELF:  e->type = 0;
        case KEY_ROTATE:
            CloseScreen();
            break;
        }
    }
    return 0;
}

static const struct evtproc selAct_evtproc[] = 
{
    { EVT_INIT, SelAct_Init },
    { EVT_SHOW, SelAct_Show },
    { EVT_KEYPRESS, SelAct_KeyPress },
    { EVT_EXIT, SelAct_Exit },
    { 0,    NULL },
};

void SelAct_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(selAct_evtproc, &evt);
    TranslateEvent(&evt);
}
