#include "messages.h"
struct messages txt;

void SetLang(unsigned char lang)
{
    switch (lang)
    {
    case 0:
        txt.yes = "Yes";
        txt.no = "No";

        txt.On = "On";
        txt.Off = "Off";
        txt.TBD = "(to be done)";

        txt.dialog_Ok = "Ok";
        txt.dialog_Cancel = "Cancel";
        txt.dialog_Reset = "Reset";
        txt.dialog_Wrong = "The number you have entered is incorrect";

        txt.go_to = "Go to the position in the file (%)";
        txt.go_to_page = "Go to the page number";
        txt.show_bookmarks = "You have no Bookmarks";
        txt.nomore_bookmarks = "You cannot create more that 64 bookmarks";
        txt.confirm_exit = "Do you really want to quit?";
        txt.confirm_delete_file = "Do you really want to delete the current file?";
        txt.confirm_clear_cache = "Do you really want to clear the cache?";
        txt.confirm_reset_opt = "Do you really want to reset the settings?";

        txt.cfg_page1_title = "Information";
        txt.cfg_page1_1_0 = "About the programm";
        txt.cfg_page1_2_0 = "Help: Reading";
        txt.cfg_page1_3_0 = "Help: Configuration";
        txt.cfg_page1_4_0 = "Help: Dialogs";

        txt.cfg_page2_title = "Font";
        txt.cfg_page2_1_0 = "Current profile: #";
        txt.cfg_page2_2_0 = "Style: #";
        txt.cfg_page2_3_0 = "Regular";
        txt.cfg_page2_4_0 = "Bold";
        txt.cfg_page2_5_0 = "Italic";
        txt.cfg_page2_6_0 = "Bold + Italic";

        txt.cfg_page3_title = "Paragraph";
        txt.cfg_page3_3_0 = "Indent for the first line (spaces)";
        txt.cfg_page3_4_0 = "Interval between the lines";
        txt.cfg_page3_5_0 = "Interval between the parapgraphs";
        txt.cfg_page3_6 = "Alignment";
        txt.cfg_page3_6_0 = "left";
        txt.cfg_page3_6_1 = "right";
        txt.cfg_page3_6_2 = "center";
        txt.cfg_page3_6_3 = "width";
        txt.cfg_page3_7 = "Hyphenation";
        txt.cfg_page3_8 = "Min symbols before/after hyph.sign";

        txt.cfg_page4_title = "Page";
        txt.cfg_page4_1_0 = "Page orientation";
        txt.cfg_page4_2_0 = "Top margin";
        txt.cfg_page4_3_0 = "Bottom margin";
        txt.cfg_page4_4_0 = "Left margin";
        txt.cfg_page4_5_0 = "Right margin";
        txt.cfg_page4_6 = "Vertical alignment";
        txt.cfg_page4_6_0 = "height";
        txt.cfg_page4_6_1 = "top";
        txt.cfg_page4_6_2 = "bottom";
        txt.cfg_page4_6_3 = "center";

        txt.cfg_page5_title = "Statusbar#1";
        txt.cfg_page5_1 = "Statusbar at the top";
        txt.cfg_page5_2_0 = "Font";
        txt.cfg_page5_3 = "Progress";
        txt.cfg_page5_3_1 = "procents";
        txt.cfg_page5_3_2 = "pages (read/all)";
        txt.cfg_page5_3_3 = "procents + pages";
        txt.cfg_page5_4 = "Battery";
        txt.cfg_page5_4_1 = "number";
        txt.cfg_page5_4_2 = "horizontal icon";
        txt.cfg_page5_4_3 = "vertical icon";
        txt.cfg_page5_4_4 = "number + horizontal icon";
        txt.cfg_page5_4_5 = "number + vertical icon";
        txt.cfg_page5_5 = "Information";
        txt.cfg_page5_5_1 = "file name";
        txt.cfg_page5_5_2 = "author";
        txt.cfg_page5_5_3 = "title";
        txt.cfg_page5_5_4 = "author+title, 1 line";
        txt.cfg_page5_5_5 = "author+title, 2 lines";
        txt.cfg_page5_5_6 = "author+title, even/odd pages";
        txt.cfg_page5_6 = "Style of the progress bar";
        txt.cfg_page5_6_1 = "thin";
        txt.cfg_page5_6_2 = "plain";
        txt.cfg_page5_6_3 = "graphical";
        txt.cfg_page5_6_4 = "no progress";
        txt.cfg_page5_7 = "Time";
        txt.cfg_page5_7_1 = "[current]";
        txt.cfg_page5_7_2 = "to read [current]";
        txt.cfg_page5_7_3 = "reading/to read [current]";
        txt.cfg_page5_7_4 = "reading/to read";
        txt.cfg_page5_7_5 = "to read";
        txt.cfg_page5_8_0 = "Color scheme: #";

        txt.cfg_page6_title = "Statusbar#2";
        txt.cfg_page6_1 = "Statusbar at the bottom";

        txt.cfg_page7_title = "Misc";
        txt.cfg_page7_1_0 = "Language: English";
        txt.cfg_page7_2_0 = "Exit confirmation";
        txt.cfg_page7_3_0 = "Save progress every N pages";
        txt.cfg_page7_4_0 = "Configure Keys for Reading";

        txt.cfg_page8_title = "Files";
        txt.cfg_page8_1_0 = "Reset the settings to default values";
        txt.cfg_page8_2_0 = "Save the settings to file (to be done)";
        txt.cfg_page8_3_0 = "Read the settings from file (to be done)";
        txt.cfg_page8_5_0 = "Clear the cache for the current file (not working)";
        txt.cfg_page8_6_0 = "Delete the current file (not working)";

        txt.cfg_font = "The Quick Brown Fox Jumped Over The Lazy Dog.";

        txt.cfg_style[0] = "regular";
        txt.cfg_style[1] = "title (fb2)";
        txt.cfg_style[2] = "subtitle";
        txt.cfg_style[3] = "text author";
        txt.cfg_style[4] = "epigraph";
        txt.cfg_style[5] = "stanza";
        txt.cfg_style[6] = "cite";
        txt.cfg_style[7] = "7";
        txt.cfg_style[8] = "8";
        txt.cfg_style[9] = "9";
        txt.cfg_style[10]= "10";
        txt.cfg_style[11]= "11";
        txt.cfg_style[12]= "12";
        txt.cfg_style[13]= "13";
        txt.cfg_style[14]= "14";
        txt.cfg_style[15]= "15";
        txt.cfg_style[16]= "16";
        txt.cfg_style[17]= "17";
        txt.cfg_style[18]= "18";
        txt.cfg_style[19]= "19";

        txt.help_page1_0="A...";
        txt.help_page1_1="About";
        txt.help_page2_0="R...";
        txt.help_page2_1="Reading";
        txt.help_page3_0="C...";
        txt.help_page3_1="Configuration";
        txt.help_page4_0="D...";
        txt.help_page4_1="Dialogs";

        txt.cfg_key[0] = "1";
        txt.cfg_key[1] = "2";
        txt.cfg_key[2] = "3";
        txt.cfg_key[3] = "4";
        txt.cfg_key[4] = "5";
        txt.cfg_key[5] = "6";
        txt.cfg_key[6] = "7";
        txt.cfg_key[7] = "8";
        txt.cfg_key[8] = "9";
        txt.cfg_key[9] = "A";
        txt.cfg_key[10]= "B";
        txt.cfg_key[11]= "C";
        txt.cfg_key[12]= "D";
        txt.cfg_key[13]= "E";
        txt.cfg_key[14]= "<|";
        txt.cfg_key[15]= "|>";
        txt.cfg_key[16]= "long 1";
        txt.cfg_key[17]= "long 2";
        txt.cfg_key[18]= "long 3";
        txt.cfg_key[19]= "long 4";
        txt.cfg_key[20]= "long 5";
        txt.cfg_key[21]= "long 6";
        txt.cfg_key[22]= "long 7";
        txt.cfg_key[23]= "long 8";
        txt.cfg_key[24]= "long 9";
        txt.cfg_key[25]= "long A";
        txt.cfg_key[26]= "long B";
        txt.cfg_key[27]= "long C";
        txt.cfg_key[28]= "long D";
        txt.cfg_key[29]= "long E";
        txt.cfg_key[30]= "long <|";
        txt.cfg_key[31]= "long |>";

        txt.cfg_act[0] = "Free";
        txt.cfg_act[1] = "Next Page";
        txt.cfg_act[2] = "Previous Page";
        txt.cfg_act[3] = "Go to First Page";
        txt.cfg_act[4] = "Go to Last Page";
        txt.cfg_act[5] = "Go to Page #N";
        txt.cfg_act[6] = "Move 10 Pages Forward";
        txt.cfg_act[7] = "Move 10 Pages Backward";
        txt.cfg_act[8] = "Move 1% Forward";
        txt.cfg_act[9] = "Move 1% Backward";
        txt.cfg_act[10]= "Move to N%";
        txt.cfg_act[11]= "Change Profile";
        txt.cfg_act[12]= "Rotate Screen";
        txt.cfg_act[13]= "Full Screen";
        txt.cfg_act[14]= "Refresh current screen";
        txt.cfg_act[15] = "Bookmark Set";
        txt.cfg_act[16]= "Go to Previous Bookmark";
        txt.cfg_act[17]= "Go to Next Bookmark";
        txt.cfg_act[18]= "Show All Bookmarks";
        txt.cfg_act[19]= "Return to Prev. Position";
        txt.cfg_act[20]= "Lock the Keys";
        break;

    case 1:
        txt.yes = "";
        txt.no = "";

        txt.On = ".";
        txt.Off = ".";
        txt.TBD = "( )";

        txt.dialog_Ok = "";
        txt.dialog_Cancel = "";
        txt.dialog_Reset = "";
        txt.dialog_Wrong = "  ";

        txt.go_to = "     (%)";
        txt.go_to_page = "   ";
        txt.show_bookmarks = "     ";
        txt.nomore_bookmarks = "    - 64";
        txt.confirm_exit = " ?";
        txt.confirm_delete_file = " ?";
        txt.confirm_clear_cache = " ?";
        txt.confirm_reset_opt = " ?";

        txt.cfg_page1_title = "";
        txt.cfg_page1_1_0 = " ";
        txt.cfg_page1_2_0 = "   ";
        txt.cfg_page1_3_0 = "  ";
        txt.cfg_page1_4_0 = "   ";

        txt.cfg_page2_title = "";
        txt.cfg_page2_1_0 = " : ";
        txt.cfg_page2_2_0 = ": ";
        txt.cfg_page2_3_0 = "";
        txt.cfg_page2_4_0 = "";
        txt.cfg_page2_5_0 = "";
        txt.cfg_page2_6_0 = " + ";

        txt.cfg_page3_title = "";
        txt.cfg_page3_3_0 = "  ( )";
        txt.cfg_page3_4_0 = "  ";
        txt.cfg_page3_5_0 = "  ";
        txt.cfg_page3_6 = "";
        txt.cfg_page3_6_0 = "  ";
        txt.cfg_page3_6_1 = "  ";
        txt.cfg_page3_6_2 = " ";
        txt.cfg_page3_6_3 = " ";
        txt.cfg_page3_7 = "";
        txt.cfg_page3_8 = ".-  / ";

        txt.cfg_page4_title = "";
        txt.cfg_page4_1_0 = " ";
        txt.cfg_page4_2_0 = " ";
        txt.cfg_page4_3_0 = " ";
        txt.cfg_page4_4_0 = " ";
        txt.cfg_page4_5_0 = " ";
        txt.cfg_page4_6 = " ";
        txt.cfg_page4_6_0 = " ";
        txt.cfg_page4_6_1 = "  ";
        txt.cfg_page4_6_2 = "  ";
        txt.cfg_page4_6_3 = " ";

        txt.cfg_page5_title = ".1";
        txt.cfg_page5_1 = " ";
        txt.cfg_page5_2_0 = " ";
        txt.cfg_page5_3 = "";
        txt.cfg_page5_3_1 = " ";
        txt.cfg_page5_3_2 = " (/)";
        txt.cfg_page5_3_3 = " + ";
        txt.cfg_page5_4 = " ";
        txt.cfg_page5_4_1 = "";
        txt.cfg_page5_4_2 = ".";
        txt.cfg_page5_4_3 = ".";
        txt.cfg_page5_4_4 = " + .";
        txt.cfg_page5_4_5 = " + .";
        txt.cfg_page5_5 = "  ";
        txt.cfg_page5_5_1 = " ";
        txt.cfg_page5_5_2 = "";
        txt.cfg_page5_5_3 = "";
        txt.cfg_page5_5_4 = "+. 1 ";
        txt.cfg_page5_5_5 = "+. 2 ";
        txt.cfg_page5_5_6 = "+. /";
        txt.cfg_page5_6 = " -";
        txt.cfg_page5_6_1 = "";
        txt.cfg_page5_6_2 = "";
        txt.cfg_page5_6_3 = "";
        txt.cfg_page5_6_4 = " ";
        txt.cfg_page5_7 = "";
        txt.cfg_page5_7_1 = "[]";
        txt.cfg_page5_7_2 = " []";
        txt.cfg_page5_7_3 = "/ []";
        txt.cfg_page5_7_4 = "/";
        txt.cfg_page5_7_5 = "";
        txt.cfg_page5_8_0 = " : ";

        txt.cfg_page6_title = ".2";
        txt.cfg_page6_1 = " ";

        txt.cfg_page7_title = "";
        txt.cfg_page7_1_0 = ": ";
        txt.cfg_page7_2_0 = " ";
        txt.cfg_page7_3_0 = "   N ";
        txt.cfg_page7_4_0 = "    ";

        txt.cfg_page8_title = "";
        txt.cfg_page8_1_0 = "     ";
        txt.cfg_page8_2_0 = "    ( )";
        txt.cfg_page8_3_0 = "    ( )";
        txt.cfg_page8_5_0 = "     (! .)";
        txt.cfg_page8_6_0 = "   (! .)";

        txt.cfg_font = "     ,   .]";

        txt.cfg_style[0] = "";
        txt.cfg_style[1] = " (fb2)";
        txt.cfg_style[2] = "subtitle (fb2)";
        txt.cfg_style[3] = "text author (fb2)";
        txt.cfg_style[4] = "epigraph (fb2)";
        txt.cfg_style[5] = "stanza (fb2)";
        txt.cfg_style[6] = "cite (fb2)";
        txt.cfg_style[7] = "7";
        txt.cfg_style[8] = "8";
        txt.cfg_style[9] = "9";
        txt.cfg_style[10]= "10";
        txt.cfg_style[11]= "11";
        txt.cfg_style[12]= "12";
        txt.cfg_style[13]= "13";
        txt.cfg_style[14]= "14";
        txt.cfg_style[15]= "15";
        txt.cfg_style[16]= "16";
        txt.cfg_style[17]= "17";
        txt.cfg_style[18]= "18";
        txt.cfg_style[19]= "19";

        txt.help_page1_0="...";
        txt.help_page1_1=" ";
        txt.help_page2_0="...";
        txt.help_page2_1="";
        txt.help_page3_0="...";
        txt.help_page3_1="";
        txt.help_page4_0="...";
        txt.help_page4_1="";

        txt.cfg_key[0] = "1";
        txt.cfg_key[1] = "2";
        txt.cfg_key[2] = "3";
        txt.cfg_key[3] = "4";
        txt.cfg_key[4] = "5";
        txt.cfg_key[5] = "6";
        txt.cfg_key[6] = "7";
        txt.cfg_key[7] = "8";
        txt.cfg_key[8] = "9";
        txt.cfg_key[9] = "A";
        txt.cfg_key[10]= "B";
        txt.cfg_key[11]= "C";
        txt.cfg_key[12]= "D";
        txt.cfg_key[13]= "E";
        txt.cfg_key[14]= "<|";
        txt.cfg_key[15]= "|>";
        txt.cfg_key[16]= " 1";
        txt.cfg_key[17]= " 2";
        txt.cfg_key[18]= " 3";
        txt.cfg_key[19]= " 4";
        txt.cfg_key[20]= " 5";
        txt.cfg_key[21]= " 6";
        txt.cfg_key[22]= " 7";
        txt.cfg_key[23]= " 8";
        txt.cfg_key[24]= " 9";
        txt.cfg_key[25]= " A";
        txt.cfg_key[26]= " B";
        txt.cfg_key[27]= " C";
        txt.cfg_key[28]= " D";
        txt.cfg_key[29]= " E";
        txt.cfg_key[30]= " <|";
        txt.cfg_key[31]= " |>";

        txt.cfg_act[0] = "";
        txt.cfg_act[1] = " ";
        txt.cfg_act[2] = " ";
        txt.cfg_act[3] = "   ";
        txt.cfg_act[4] = "   ";
        txt.cfg_act[5] = "  N- ";
        txt.cfg_act[6] = "  10 . ";
        txt.cfg_act[7] = "  10 . ";
        txt.cfg_act[8] = "  1% ";
        txt.cfg_act[9] = "  1% ";
        txt.cfg_act[10] = "  N- %";
        txt.cfg_act[11] = " ";
        txt.cfg_act[12]= " ";
        txt.cfg_act[13]= "   ";
        txt.cfg_act[14]= " ";
        txt.cfg_act[15]= " ";
        txt.cfg_act[16]= "   ";
        txt.cfg_act[17]= "   ";
        txt.cfg_act[18]= "  ";
        txt.cfg_act[19]= "  ./";
        txt.cfg_act[20]= " ";
        break;
    }
}
