/* Simple UTF-8 to CP-1251 recoding routine
 * Header file: utf8.h
 * Change History:
 * 10.09.2007 - Original version by Pyk
 *
 * Copyright (c) 2007 Pykhonin Victor (aka Pyk)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <wolf.h>

#ifndef _UTF8_H
#define _UTF8_H

void DecodeUTF8(void *pBuf, int nBufSize, int *nBytesDecoded, int *nCharsDecoded);
void Decode1UTF8(void *pBuf, int nBufSize, int *nBytesDecoded, int *nCharsDecoded);

#endif
